window.addEventListener('load', init, false);

var player, playerGun;

var hemisphereLight, shadowLight, spotLight;

var level = [
	[1,1,1,1,1,1,1,1,1,1],
	[1,0,0,0,0,0,0,0,2,1],
	[1,0,0,0,0,0,0,0,0,1],
	[1,0,0,1,1,1,0,1,0,1],
	[1,0,0,0,3,0,0,0,0,1],
	[1,0,0,2,0,1,1,0,0,1],
	[1,0,1,2,0,0,1,1,0,1],
	[1,0,1,1,0,2,0,0,0,1],
	[1,0,0,0,0,0,0,0,2,1],
	[1,1,1,1,1,1,1,1,1,1],
];
 
function createLights() {
    hemisphereLight = new THREE.HemisphereLight(0xaaaaaa, 0x000000, 0.9) 
    	
    shadowLight = new THREE.DirectionalLight(0xffffff, 0.9, 100); 
    shadowLight.position.set(150, 350, 350);    
    shadowLight.castShadow = true; 
    shadowLight.shadow.camera.left = -100;
    shadowLight.shadow.camera.right = 100;
    shadowLight.shadow.camera.top = 100;
    shadowLight.shadow.camera.bottom = -100;
    shadowLight.shadow.camera.near = 1;
    shadowLight.shadow.camera.far = 1000; 
    shadowLight.shadow.mapSize.width = 2048;
    shadowLight.shadow.mapSize.height = 2048;
	
	
    Globals.scene.add(hemisphereLight);  
    Globals.scene.add(shadowLight);
}

function init()
{
	var mesh;
	Globals.Init();	
	window.addEventListener('resize', Resize, false);

	createLights();
	
    mesh = new THREE.Mesh(new THREE.PlaneGeometry(100, 100, 1, 1), new THREE.MeshLambertMaterial({map: Globals.textures.concrete}));
    mesh.quaternion.setFromAxisAngle(new THREE.Vector3(1,0,0), -Math.PI / 2);
	mesh.position.set(50, 0, 50);
	mesh.receiveShadow = true;
	mesh.castShadow = true;
    Globals.scene.add(mesh);
	
	for (var y in level)
		for (var x in level[y])
		{
			switch (level[y][x]) {
				case 1:
					mesh = new THREE.Mesh(new THREE.BoxGeometry(10, 10, 10), new THREE.MeshLambertMaterial({map: Globals.textures.brick})); 
					mesh.position.set(x * 10 + 5, 5, y * 10 + 5);
				break;
				case 2:
					mesh = new THREE.Mesh(new THREE.BoxGeometry(9, 9, 9), new THREE.MeshLambertMaterial({map: Globals.textures.wood})); 
					mesh.position.set(x * 10 + 5, 4.5, y * 10 + 5);
				break;
				case 3:
					level[y][x] = 0;
					mesh = new THREE.Mesh(new THREE.BoxGeometry(6, 3, 6), new THREE.MeshLambertMaterial({map: Globals.textures.metall})); 
					mesh.position.set(x * 10 + 5, 1.5, y * 10 + 5);      
					player = mesh;
					
					playerGun = new THREE.Mesh(new THREE.BoxGeometry(5, 1, 1), new THREE.MeshLambertMaterial({map: Globals.textures.metall}));
					playerGun.receiveShadow = true;
					playerGun.castShadow = true;
					playerGun.position.set(4, 1.5, 0);
					mesh.add(playerGun);
				break;
			}
			
			Globals.scene.add(mesh);      
			mesh.receiveShadow = true;
			mesh.castShadow = true;
		}

	Update();
}

function Resize()
{
	Globals.Resize();
}

var rotationTime = 0;
var fromAngle = 0;
var toAngle = 0;
var moveTime = 0;
var vector = {x: 0, z: 0};
var fromPosition = {x: 0, z: 0};

function Update()
{
	Globals.Update(function(){
		
		if(moveTime > 0)
		{
			moveTime -= Globals.delta;
			if (moveTime <= 0)
			{
				player.position.x = fromPosition.x + vector.x;	
				player.position.z = fromPosition.z + vector.z;	
			}
			else
			{
				player.position.x = fromPosition.x + animate(vector.x, 0, moveTime);	
				player.position.z = fromPosition.z + animate(vector.z, 0, moveTime);	
			}
		}
		else
			if(rotationTime <= 0)
			if(Input.isKeyDown(Keys.W) || Input.isKeyDown(Keys.S) || Input.isKeyDown(Keys.A) || Input.isKeyDown(Keys.D))
			{		
				if(Input.isKeyDown(Keys.W))
					vector = new THREE.Vector3(-Math.cos(-playerGun.rotation.y), 0, -Math.sin(-playerGun.rotation.y))
				else
				if(Input.isKeyDown(Keys.S))
					vector = new THREE.Vector3(Math.cos(-playerGun.rotation.y), 0, Math.sin(-playerGun.rotation.y))		
				else
				if(Input.isKeyDown(Keys.A))
					vector = new THREE.Vector3(-Math.sin(-playerGun.rotation.y), 0, Math.cos(-playerGun.rotation.y))	
				else
				if(Input.isKeyDown(Keys.D))
					vector = new THREE.Vector3(Math.sin(-playerGun.rotation.y), 0, -Math.cos(-playerGun.rotation.y))	
				
				var p = player.position.clone();
				p.sub(new THREE.Vector3(5, 0, 5));
				p.divide(new THREE.Vector3(10, 1, 10));
				p.add(vector);
				if (level[Math.floor(p.z)][Math.floor(p.x)] == 0)
				{
					vector.multiply(new THREE.Vector3(10, 1, 10));
					moveTime = 1;	
					fromPosition.x = player.position.x;
					fromPosition.z = player.position.z;
				}
			}
		
		if(rotationTime > 0)		
		{
			rotationTime -= Globals.delta;
			if (rotationTime <= 0)
				playerGun.rotation.y = toAngle;
			else
				playerGun.rotation.y = animate(toAngle, fromAngle, rotationTime * 2);			
		}
		else
		if(moveTime <= 0)
		{
			if (Input.isKeyDown(Keys.Q))
			{
				rotationTime = 0.5;
				fromAngle = playerGun.rotation.y;
				toAngle = playerGun.rotation.y + THREE.Math.degToRad(90);
			}
			if (Input.isKeyDown(Keys.E))
			{				
				rotationTime = 0.5;
				fromAngle = playerGun.rotation.y;
				toAngle = playerGun.rotation.y - THREE.Math.degToRad(90);
			}
		}
		
		playerGun.position.x = -Math.cos(-playerGun.rotation.y) * 2.5;
		playerGun.position.z = -Math.sin(-playerGun.rotation.y) * 2.5;		
		Globals.camera.position.x = player.position.x + Math.cos(-playerGun.rotation.y) * 4.5;
		Globals.camera.position.z = player.position.z + Math.sin(-playerGun.rotation.y) * 4.5;	
		var a = player.position.clone();
		a.add(playerGun.position);
		a.y += 3;
		Globals.camera.lookAt(a);
	});
	requestAnimationFrame(Update);
}